#ifndef _HEADERS_DEFINITIONS_H
#define _HEADERS_DEFINITIONS_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define TitleCaption   "SQL-Exchange Server"
#define FileVersion    "1.0.1.3"
#define RegistryKey    "Software\\Enginuity\\SQL-Exchange\\Server"
#define LBSEPERATOR    "____________________________________________________________________________________________________"
#define DataDirectory  "C:\\ImportDB"

#define FileBufferSize 512

#define AuthenticationString "trIeSPiUhouDlUwRLe5hie2H5awRoupiaDi8zI0fo3Y7u6R703r7e6rLacrouChi"

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define USERCRYPTFLAGS      ROUNDMUTATION | SWAPMATRIX | ROUNDRESULT | NONREPETITION | ENSUREOFFSET
#define BASECOMMCRYPTFLAGS  ROUNDMUTATION | SWAPMATRIX | ROUNDRESULT | NONREPETITION | ENSUREOFFSET
#define MESSAGECRYPTFLAGS   ROUNDMUTATION | SWAPMATRIX | ROUNDRESULT | NONREPETITION | ENSUREOFFSET

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define AUTH_CMD_DISCONNECT       0x1
#define AUTH_CMD_FAILED           0x2
#define AUTH_CMD_OK               0x3
#define AUTH_CMD_SUCCESS          0x4
#define AUTH_CMD_UNKNOWN          0x5

#define CLIENTVER_AUTOUPDATE      0x1
#define CLIENTVER_CURRENT         0x2
#define CLIENTVER_ERROR           0x3
#define CLIENTVER_OUTDATED        0x4
#define CLIENTVER_SUPPORTED       0x5

#define COMMAND_RESULT_DISCONNECT 0x1
#define COMMAND_RESULT_ERROR      0x2
#define COMMAND_RESULT_OK         0x3
#define COMMAND_RESULT_UNKNOWN    0x4

#define SENDNEXTSTATEMENT_DONE    0x1
#define SENDNEXTSTATEMENT_FAILURE 0x2
#define SENDNEXTSTATEMENT_SUCCESS 0x3

//---------------------(Instance Definitions & Dialog Handle Definitions)
HINSTANCE MainInstance = NULL; 
HWND ServerDialog_hWnd = NULL;

//---------------------(Global Variables)

bool gbApplicationRunning = false;
bool gbDebugMode = false;
bool gbIsServerDialogOpen = false;
bool gbKillApplication = false;

char *gsBaseCommKey  = "6riupiekieB8uphiuspi0tr6azl2piAth6us6ieko2zoap2818UviapHlEvo5joe";

char gsSessionLogDir[256];
char gsSQLIndexDatabase[255];
char gsSQLIndexDriver[255];
char gsSQLIndexPassword[255];
char gsSQLIndexServer[255];
char gsSQLIndexUserID[255];

DWORD glListenPort     = 0;
DWORD glTCPLoopDelay   = 0;

FILE *gfSessionLog = NULL;

int giMaxConnections   = 0;

_NASCCL BaseCommCript;

SQLBasics WebPortalIndex;

struct _SQLImportMembers{
    char **ColumbNames;
    char **SingleRowData;
};

struct _ServerDialogInfo{
    HWND ServerList_hWnd;
    HMENU Menu_hWnd;
}; _ServerDialogInfo SDI;

struct _ClientInfo{
    bool Authenticated;

    char ClientVersion[10];
    char CompanyDB[32];
    char CompanyName[32];
    char CompanyPassword[64];
    char FileName[256];

    DWORD DataCRC;
    DWORD FileSize;

    HSTMT StatementHandle;

    SQLBasics DBClass;

}; _ClientInfo CI[MAXCLIENTS];

//---------------------(Dialog Prototypes)
BOOL CALLBACK ServerDialog(HWND, UINT, WPARAM, LPARAM);

//---------------------(Function Prototypes)
bool GetRegistryValues(void);
bool ImportSQLResults(int, char *);
bool InitCryptography(void);
bool Initialize(void);
bool IsValidCompanyPassword(int);
bool OpenLogFile(void);
bool ReceiveFileData(int, char *);
bool ServerSend(int, char *, int);
bool SimpleServerSend(int, char *);
bool StartServer(void);
bool StopServer(void);
bool UninitCryptography(void);
bool Uninitialize(void);
bool WaitOnApplicationToExit(void);
bool xMainEntry(void);

int AuthenticateClient(int);
int AuthProcessCommand(int, char *, int);
int IsValidClientVersion(int, char *);
int ProcessCommand(int, char *, int);
int SendNextStatement(int);

void CreateFolderStructure(char *);
void FatalError(char *);
void FreeSingleClientInfo(int);
void FreeSingleRowData(struct _SQLImportMembers *);
void FreeSingleRowDataColumbs(struct _SQLImportMembers *, int);
void InitClientInfo(void);
void WriteLog(char *);

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

